"use strict";

function a2dom(arr) {
  let tag   = arr[0];  // 配列の最初の値がタグ名
  let attrs = arr[1];  // 2番目の値が属性（名前と値）
  let pos   = 2;       // 3番目以降は子テキスト
  /// DOM要素を作成
  let elem = document.createElement(tag);
  /// 属性を追加（nullとundefinedは無視）
  let a = attrs;
  if (typeof a === 'object' && a != null && !$.isArray(a)) {
    for (let k in attrs) {
      let v = attrs[k];
      if (v === true || v === false) { // 真偽値なら（例：checked）
        elem[k] = v;                   //   プロパティとして設定
      } else if (v != null) {          // nullやundefinedでないなら
        elem.setAttribute(k, v);       //   属性値として設定
      }
    }
  } else {
    pos = 1; // 2番目が属性ではなかった ＝ 2番目以降が子テキスト
  }
  /// 配列の残りの値を、子ノードとして追加
  for (let i = pos, n = arr.length; i < n; i++) {
    let x = arr[i];
    if ($.isArray(x)) {            // 値が配列なら
      let child = a2dom(x);        //   a2dom()を再帰的に呼び出して
      elem.appendChild(child);     //   子要素として追加
    } else if (x != null) {        // 値がnullやundefinedでないなら
      let text = document.createTextNode(x);
      elem.appendChild(text);      //   テキストを追加
    }
  }
  /// 作成したDOM要素を返す
  return elem;
}

/// for Node.js
if (typeof module !== 'undefined') { module.exports = a2dom; }
