"use strict";

let ConcentrationGame = (function() {

  /// ユーティリティ
  let U = {
    init: function() {
    }
  };

  /// モデル（コアとなるロジックやデータ）
  let M = {
    init: function() {
      M.board = M.createBoard();  // ボード（4×4のマス目）を生成
    }
    /// ボードを生成する
  , createBoard: function() {
      return [
        [1, 2, 3, 4]
      , [1, 2, 3, 4]
      , [5, 6, 7, 8]
      , [5, 6, 7, 8]
      ];
    }
  };

  /// コントローラ（イベントハンドラ）
  let C = {
    init: function() {
      C.registerHandlers();    // イベントハンドラを登録
      V.renderBoard(M.board);  // ボードを表示
    }
    /// イベントハンドラを登録
  , registerHandlers: function() {
    }
  };

  /// ビュー（表示に関する機能）
  let V = {
    init: function() {
    }
    /// ボードを表示
  , renderBoard: function(board) {
      let context = {
        board: board
      };
      $('#tmpl-board').renderWith(context, '#board');
    }
  };

  /// 初期設定
  function init() {
    U.init();
    M.init();
    V.init();
    C.init();
  }

  return {init: init, U: U, M: M, C: C, V: V};

})();

$(ConcentrationGame.init);
