"use strict";

// ===== コアとなる機能 =====

// メッセージを作成する
function buildMessage(name) {
  return "Hello, " + name + "!";       // 例："Hello, World!"
}

// ===== 表示に関する機能 =====

// メッセージを表示する
function showMessage(msg) {
  $('#message').text(msg);             // メッセージ欄に表示
}

// アラートを表示する
function showAlert(msg) {
  alert(msg);                          // アラートを表示
}

// 名前欄とメッセージ欄をクリアする
function clear() {
  $('#name').val("");                  // 名前欄をクリア
  $('#message').text("");              // メッセージ欄をクリア
}

// ===== ユーティリティ関数 =====

// 文字列の前後の空白を取り除く
function trimString(str) {
  return str.trim();
  // または全角空白も削除するなら
  //return str.replace(/^[\s　]+/, '').replace(/[\s　]+$/, '');
}

// ===== イベントハンドラ =====

// 「表示」ボタンがクリックされたときのイベントハンドラ
function doShowMessage() {
  let name = $('#name').val();         // 名前欄の値を取得
  name = trimString(name);             // 前後の空白を除去
  if (! name) {                        // 名前が空なら
    showAlert("Enter your name.");     //   アラートを表示
  } else {                             // 名前が空でなければ
    let msg = buildMessage(name);      //   メッセージを作成
    showMessage(msg);                  //   メッセージを表示
  }
}

// 「クリア」ボタンがクリックされたときのイベントハンドラ
function doClear() {
  clear();                             // 名前欄とメッセージ欄をクリア
}

// ボタンにイベントハンドラを登録する
function registerHandlers() {
  $('#show-btn').on('click', doShowMessage); // 「表示」ボタン
  $('#clear-btn').on('click', doClear);      // 「クリア」ボタン
}

$(function() {
  registerHandlers();                  // イベントハンドラを登録
});
